package org.eclipse.weaver.extension.byADL.init;

import java.util.List;

import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.weaver.core.WeaverModelManager;
import org.eclipse.weaver.exception.WeaverException;
import org.eclipse.weaver.extension.init.WeaverInitialize;

/**
 * ByADL weaver initializer; it may be useful for future extensions.
 * 
 * @author - Ivano Malavolta (Department of Computer Science)<br>
 * 		   - Universit dell'Aquila (Italy)
 * @since 1.0
 */
public class ByADLWeaverInitialize extends WeaverInitialize {
        
    public ByADLWeaverInitialize() {
    	super();
    }
    
    /* (non-Javadoc)
     * @see org.eclipse.weaver.extension.init.WeaverInitialize#initWeaverMetamodel(org.eclipse.weaver.core.WeaverModelManager, org.eclipse.emf.edit.domain.EditingDomain, java.lang.String, java.util.List, java.util.List, java.util.List, java.util.List, boolean)
     * 
     * This method is overriden to do not permit to have weaving models with more than one root
     */
    public void initWeaverMetamodel(WeaverModelManager manager, EditingDomain editingDomain, 
    		String wModelName, List wModelRefClassNames, List wReferenceNames, 
    		List wModelRef_name, List wModelRef_ref, boolean isNew){
   		//super.initWeaverMetamodel(manager, editingDomain, wModelName, wModelRefClassNames, wReferenceNames, wModelRef_name, wModelRef_ref, isNew);
    	this.setModelManager(manager);
        this.setWModelName(wModelName);
        // Create instance of WModel if new
        try {
			if (isNew && this.getModelManager().getWeavingModel(editingDomain).getContents().isEmpty())
			   manager.helper.createWeavingElementInRes(wModelName,editingDomain);
		} catch (WeaverException e) {
			e.printStackTrace();
		}           
        // Create instance(s) of WModelRef if not exist                  
        setWovenModelResources(wModelRefClassNames,wReferenceNames, wModelRef_name, wModelRef_ref, 
        		editingDomain, isNew);  
   }
}
