package org.eclipse.weaver.extension.byADL.providers;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.weaver.providers.IIdentifierAdapter;
import org.eclipse.weaver.providers.XMIIdentifierAdapter;

/**
 * WElementRefItemProvider DUALLy extension
 * 
 * @author - Ivano Malavolta (Department of Computer Science)<br>
 * 		   - Universit dell'Aquila (Italy)
 * @since 1.0
 */
public class ByADLElementRefItemProvider extends ByADLWElementItemProvider  implements IIdentifierAdapter {

	private IIdentifierAdapter adapter;
	
	public ByADLElementRefItemProvider(){
		super();
		this.adapter = new XMIIdentifierAdapter(null);
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.weaver.providers.IIdentifierAdapter#setID(java.lang.Object)
	 */
	public void setID(Object obj) {
		adapter.setID(obj);
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.weaver.providers.IIdentifierAdapter#getID()
	 */
	public Object getID() {		
		return adapter.getID();
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.weaver.providers.IIdentifierAdapter#getTarget()
	 */
	public Notifier getTarget() {		
		return adapter.getTarget();
	}

	/* (non-Javadoc)
	 * @see org.eclipse.weaver.providers.IIdentifierAdapter#setTarget(org.eclipse.emf.common.notify.Notifier)
	 */
	public void setTarget(Notifier source) {
		adapter.setTarget(source);
	}
	
	/* 
	 *    
     * This method is overriden to avoid problems
     * derived from the generic weaving panel.
     * It does nothing.
	 * 
	 * 
	 * (non-Javadoc)
	 * @see org.eclipse.emf.common.notify.Adapter#notifyChanged(org.eclipse.emf.common.notify.Notification)
	 */
	public void notifyChanged(Notification notification){
		try {
			super.notifyChanged(notification);
		} catch (Exception e) {
			//e.printStackTrace();
		}
	}
}



