package org.eclipse.weaver.extension.byADL.providers;

import java.net.URL;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.provider.EcoreEditPlugin;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.viewers.IColorProvider;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Display;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;

public class ByADLWovenModelLabelProvider extends AdapterFactoryLabelProvider  implements IColorProvider  {

	/**
	 * Overrided constructor.
	 * 
	 * @param adapterFactory
	 */
	public ByADLWovenModelLabelProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider#getImage(java.lang.Object)
	 * 
	 * This method is overrided to get the Ecore default images directly from the Ecore plugin.
	 */
	@Override
	public Image getImage(Object element) {
		if(element instanceof EPackage) {
			return ImageDescriptor.createFromURL((URL) EcoreEditPlugin.getPlugin().getImage("full/obj16/EPackage")).createImage();

		}
		if(element instanceof EClassifier) {
			return ImageDescriptor.createFromURL((URL) EcoreEditPlugin.getPlugin().getImage("full/obj16/EClass")).createImage();

		}
		if(element instanceof EAttribute) {
			return ImageDescriptor.createFromURL((URL) EcoreEditPlugin.getPlugin().getImage("full/obj16/EAttribute")).createImage();

		}
		if(element instanceof EReference) {
			return ImageDescriptor.createFromURL((URL) EcoreEditPlugin.getPlugin().getImage("full/obj16/EReference")).createImage();

		}
		return super.getImage(element);
	}

	@Override
	public Color getBackground(Object element) {
		return null;
	}

	@Override
	public String getText(Object element) {
		String result;
		if(element instanceof ENamedElement) {
			result = ((ENamedElement) element).getName();
		} else {
			result = element == null ? "" : element.toString();
		}
		return result;
	}

	@Override
	public Color getForeground(Object element) {
		Color color = null;
		if(element instanceof EStructuralFeature) {
			color = Display.getCurrent().getSystemColor(SWT.COLOR_DARK_GRAY);
		}
		return color;
	}

	@Override
	public void notifyChanged(Notification notification) {
		try {
			super.notifyChanged(notification);
		} catch (Exception e) {
			//e.printStackTrace();
		}
	}

}
