package org.eclipse.weaver.extension.byADL.transformation;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * Class containing the configuration elements for a transformation.
 * This class is taken from the transformations plug-in of AMW.
 * 
 * @author - Ivano Malavolta (Department of Computer Science)<br>
 * 		   - Universit dell'Aquila (Italy)
 * @since 1.0
 */
public abstract class TransformationConfig {
	public String plugin;
	public String transformation;
	public String suffix;
	public String description;
	public String category;
	public List bindings;
	public String type;
	public boolean hasConfigurationModel;
	
	public Object clone() {
	
		TransformationConfig tc = new TransformationConfig () {};    	
		tc.type = type;
		tc.plugin = plugin;
		tc.transformation = transformation;
		tc.suffix = suffix;
		tc.description = description;
		tc.category = category;
		tc.bindings = new ArrayList();
		tc.hasConfigurationModel = false;
				
		for (Iterator bindList = bindings.iterator(); bindList.hasNext();) {
			TBinding element = (TBinding) bindList.next();
			TBinding b = new TBinding () {};
			b.weavingReference = element.weavingReference;
			b.header = element.header;
			b.description = element.description;
			b.metamodelPath = element.metamodelPath;
			b.metamodelHeader = element.metamodelHeader;
			b.path = element.path;
			b.isExtraBinding = element.isExtraBinding;
			tc.bindings.add(b);						
			
		}
		return tc;
	}
}

